﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace testLib
{   
    public interface ICBinary{
        string Test { get; }
        void CleanUp();
        void GetBytes(int address, int size);
        void GetCSBuf(ref int address, ref int size);
    }

    public class CBinary : ICBinary
    {
        private int mAddress;
        private int mSize;

        public string Test
        {
            get { return "blahblah"; }
        }

        public void GetCSBuf(ref int address, ref int size)
        {
            address = mAddress;
            size = mSize;
        }

        public void CleanUp()
        {
            if(mAddress!=0) Marshal.FreeHGlobal((IntPtr)mAddress);
            mAddress = 0;
        }

        public void GetBytes(int address, int size)
        {
            string msg="";
            byte[] b = new byte[size];
            Marshal.Copy((IntPtr)address, b, 0, size);

            for (int i = 0; i < size; i++)
            {
                msg += ((int)b[i]).ToString("X") + " ";
            }

            MessageBox.Show("In CSharp: Hexdump of binary data from VB is:\n\n" + msg);

            byte[] c = new byte[5];
            for (int i = 0; i < 5; i++) c[i] = (byte)(0x90 + i);

            mAddress = (int)Marshal.AllocHGlobal(5);
            mSize = 5;

            if(mAddress!=0) Marshal.Copy(c, 0, (IntPtr)mAddress, size);

        }



    }
}
